<?php
//error_reporting(E_ERROR | E_WARNING | E_PARSE);
//初始化
define('DISABLEXSSCHECK', true);
require_once '../../../source/class/class_core.php';
$_GET['formhash']=formhash();//自动验证

$discuz = C::app();
$cachelist = array('plugin');
$discuz->cachelist = $cachelist;
$discuz->init();

$_G['siteurl']=trim(str_replace('/source/plugin/skycaijidz', '', $_G['siteurl']),'/').'/';

ob_clean();//清除输出
ob_start();//缓存输出


require_once 'skycaiji2cms/skycaiji2cms.php';
$scj2cms=new skycaiji2cms(
    DISCUZ_ROOT.'source/plugin/skycaijidz/',
    $_G['siteurl'].'source/plugin/skycaijidz/',
    $_G['charset'],
    false
);

$scj2cms->pluginConfig=$_G['cache']['plugin']['skycaijidz'];//插件配置
$scj2cms->pluginLang=lang('plugin/skycaijidz');//指定语言包

if(!in_array('skycaijidz',$_G['setting']['plugins']['available'])) {
    $scj2cms->returnJson(0,lang('plugin/skycaijidz','closed'));
}


function funcGetPost($key){
    return $_GET[$key];
}
$scj2cms->funcGetPost='funcGetPost';

//终止函数
function pluginExitDo(){
    global $_G,$scj2cms;
    $html=ob_get_contents();//获取输出
    $html=trim($html);
    ob_clean();//清理页面
    
    if(!empty($html)){
        if(strpos($html, '{')===0){
            //是json
            exit($html);
        }else{
            $data=array(
                'id'=>'',
                'target'=>'',
                'desc'=>'',
                'error'=>'',
            );
            //获取错误信息
            if(preg_match('/errorhandle_\(\'(.+?)\'/',$html,$error)){
                $data['error']=strip_tags($error[1]);
            }elseif(preg_match('/<div[^<>]*?id\s*=[\'\"]messagetext[\'\"][^<>]*?>[\s\r\n]*<p[^<>]*>([\s\S]+?)<\/p>/',$html,$error)){
                $data['error']=strip_tags($error[1]);
            }
            if(empty($data['error'])){
                if(preg_match('/portal\.php\?mod=portalcp\&ac=article\&catid=\d+\&op=edit\&aid=(\d+)/i',$html,$aid)){
                    //发布成功
                    $aid=$aid[1];
                    $data['id']=$aid;
                    $data['target']=$_G['siteurl'].'portal.php?mod=view&aid='.$aid;
                }
            }
            $scj2cms->returnJson($data['id'],$data['error'],$data['target'],$data['desc']);
        }
    }
    $scj2cms->returnJson(0,'failed');
}
register_shutdown_function('pluginExitDo');

//发布函数
function funcApiPost(){
    global $_G,$scj2cms;
    if(empty($_GET['title'])){
        $scj2cms->returnJson(0,lang('plugin/skycaijidz','error_art_title'));
    }
    if(empty($_GET['content'])){
        $scj2cms->returnJson(0,lang('plugin/skycaijidz','error_art_content'));
    }
    //分类
    $catid=$_GET['catid'];
    loadcache('portalcategory');
    $portalcategory = $_G['cache']['portalcategory'];
    $existCat=false;
    if($catid&&!empty($portalcategory)){
        foreach ($portalcategory as $k=>$v){
            if($v['catid']==$catid||$v['catname']==$catid){
                $catid=$v['catid'];
                $existCat=true;
                break;
            }
        }
    }
    $catid=$existCat?$catid:0;
    if($catid<=0){
        $scj2cms->returnJson(0,lang('plugin/skycaijidz','error_art_catid'));
    }
    $_GET['catid']=$_POST['catid']=$catid;
    
    $author=$scj2cms->randLine($scj2cms->pluginConfig['author']);
    if(empty($author)){
        $scj2cms->returnJson(0,lang('plugin/skycaijidz','error_author'));
    }
    //加载用户
    require_once DISCUZ_ROOT.'./source/function/function_magic.php';
    require_once DISCUZ_ROOT.'./source/function/function_editor.php';
    $member=getuserinfo($author);
    if(empty($member)){
        $scj2cms->returnJson(0,lang('plugin/skycaijidz','error_author').':'.$author);
    }
    //标签
    if(isset($_GET['tag'])){
        $tag=explode(',', $_GET['tag']);
        $tags=array();
        foreach ($tag as $v){
            $tags[$v]='on';
        }
        $_GET['tag']=$_POST['tag']=$tags;
    }
    
    $_G['uid'] = intval($member['uid']);
    $_G['username'] = $member['username'];
    $_G['adminid'] = $member['adminid'];
    $_G['groupid'] = $member['groupid'];
    $_G['formhash'] = formhash();
    $_G['session']['invisible'] = getuserprofile('invisible');
    $_G['member'] = $member;
    loadcache('usergroup_'.$_G['groupid']);
    
    //发帖参数
    $_GET['ac'] = 'article';
    $_GET['op']='add';
    $_GET['articlesubmit']=true;
    $_GET['formhash']=formhash();
    
    //function submitcheck验证
    $_G['group']['seccode']=0;//关闭验证码
    $_G['group']['disablepostctrl']=1;//取消发帖间隔
    
    $_SERVER['REQUEST_METHOD']='POST';
    $_SERVER['HTTP_REFERER']=$_G['siteurl'].'portal.php';
    //showmessage设置
    $_G['inajax']=1;//防止showmessage header跳转
    
    require_once DISCUZ_ROOT.'./source/function/function_portal.php';
    require_once DISCUZ_ROOT.'./source/function/function_home.php';
    require_once DISCUZ_ROOT.'./source/module/portal/portal_portalcp.php';
}
$scj2cms->funcApiPost='funcApiPost';
$scj2cms->apiPost();

?>