<?php
function check_cms_defined(){
    if(!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
        exit('Access Denied');
    }
}
check_cms_defined();
define('skycaiji2cms_head_func', 'check_cms_defined');

if(!in_array('skycaijidz',$_G['setting']['plugins']['available'])) {
	cpmsg(lang('plugin/skycaijidz','closed'));
}
loadcache('plugin');
loadcache('groupreadaccess');
$pluginConfig=$_G['cache']['plugin']['skycaijidz'];
$pluginConfig=is_array($pluginConfig)?$pluginConfig:array();
if(empty($pluginConfig)||empty($pluginConfig['apikey'])){
    cpmsg(lang('plugin/skycaijidz','setting'),$_G['siteurl'].ADMINSCRIPT.'?action=plugins&operation=config&do='.$_GET['do']);
}


$isThread=$_GET['ac']=='thread'?true:false;//是否是帖子

//初始化
require_once 'skycaiji2cms/skycaiji2cms.php';
$scj2cms=new skycaiji2cms(
    DISCUZ_ROOT.'source/plugin/skycaijidz/',
    $_G['siteurl'].'source/plugin/skycaijidz/',
    $_G['charset'],
    false
);
$scj2cms->apiUrl=$scj2cms->pluginUrl.($isThread?'post.php':'article.php');

$scj2cms->pluginConfig=$pluginConfig;//插件配置
$scj2cms->pluginLang=lang('plugin/skycaijidz');//指定语言包

if($isThread){
    $formRequired=array('fid','subject','message');//必填
    $formOptional=array('tags','readperm','replycredit_extcredits','replycredit_times','replycredit_membertimes','replycredit_random','price','rushreply','rushreplyfrom','rushreplyto','rewardfloor','replylimit','stopfloor','creditlimit','isanonymous','hiddenreplies','ordertype','allownoticeauthor','usesig','htmlon','allowimgcode','allowimgurl','parseurloff','smileyoff','bbcodeoff','imgcontent','sticktopic','addtodigest');//选填
}else{
    $formRequired=array('title','content','catid');//必填
    $formOptional=array('from','fromurl','dateline','url','author','summary','tag');//选填
}

$scj2cms->formRequired=array();
foreach ($formRequired as $k){
    $scj2cms->formRequired[$k]=$scj2cms->pluginLang['api_'.($isThread?'data':'art').'_'.$k];
}

$scj2cms->formOptional=array();
foreach ($formOptional as $k){
    $scj2cms->formOptional[$k]=$scj2cms->pluginLang['api_'.($isThread?'data':'art').'_'.$k];
}
if($isThread){
    //权限
    foreach($_G['cache']['groupreadaccess'] as $val){
        $scj2cms->formOptional['readperm'].=$val['grouptitle'].' '.$val['readaccess'].', ';
    }
    $scj2cms->formOptional['readperm'].=$scj2cms->pluginLang['highest_right'].' 255';
}
$scj2cms->formView();
?>